Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_rename.def
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_rename.def	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_rename.def	(revision 429)
@@ -6,11 +6,7 @@
 target_hrt_initialize
 target_hrt_terminate
-target_hrt_set_event
-target_hrt_raise_event
 target_hrt_handler
 target_ovrtimer_initialize
 target_ovrtimer_terminate
-target_ovrtimer_stop
-target_ovrtimer_get_current
 target_ovrtimer_handler
 
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_rename.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_rename.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_rename.h	(revision 429)
@@ -15,11 +15,7 @@
 #define target_hrt_initialize		_kernel_target_hrt_initialize
 #define target_hrt_terminate		_kernel_target_hrt_terminate
-#define target_hrt_set_event		_kernel_target_hrt_set_event
-#define target_hrt_raise_event		_kernel_target_hrt_raise_event
 #define target_hrt_handler			_kernel_target_hrt_handler
 #define target_ovrtimer_initialize	_kernel_target_ovrtimer_initialize
 #define target_ovrtimer_terminate	_kernel_target_ovrtimer_terminate
-#define target_ovrtimer_stop		_kernel_target_ovrtimer_stop
-#define target_ovrtimer_get_current	_kernel_target_ovrtimer_get_current
 #define target_ovrtimer_handler		_kernel_target_ovrtimer_handler
 
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_stddef.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_stddef.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_stddef.h	(revision 429)
@@ -1,43 +1,2 @@
-/*
- *  TOPPERS Software
- *      Toyohashi Open Platform for Embedded Real-Time Systems
- *
- *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
- *              Graduate School of Information Science, Nagoya Univ., JAPAN
- *  Copyright (C) 2011-2016 by Embedded and Real-Time Systems Laboratory
- *              Graduate School of Information Science, Nagoya Univ., JAPAN
- *
- *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
- *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
- *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
- *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
- *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
- *      スコード中に含まれていること．
- *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
- *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
- *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
- *      の無保証規定を掲載すること．
- *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
- *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
- *      と．
- *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
- *        作権表示，この利用条件および下記の無保証規定を掲載すること．
- *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
- *        報告すること．
- *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
- *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
- *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
- *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
- *      免責すること．
- *
- *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
- *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
- *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
- *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
- *  の責任を負わない．
- *
- *  $Id$
- */
-
 /*
  *		t_stddef.hのチップ依存部（RZ/A1用）
@@ -46,4 +5,6 @@
  *  されるファイル）のみからインクルードされる．他のファイルから直接イ
  *  ンクルードしてはならない．
+ * 
+ *  $Id$
  */
 
@@ -64,4 +25,14 @@
 
 /*
+ *  開発環境で共通な定義
+ */
+#ifndef TOPPERS_MACRO_ONLY
+#include <stdint.h>
+#endif /* TOPPERS_MACRO_ONLY */
+
+#define TOPPERS_STDFLOAT_TYPE1
+#include "tool_stddef.h"
+
+/*
  *  コアで共通な定義
  */
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_sym.def
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_sym.def	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_sym.def	(revision 429)
@@ -1,4 +1,4 @@
-TARGET_RZA1H,true,bool,defined(TARGET_RZA1H)
-TARGET_RZA1L,true,bool,defined(TARGET_RZA1L)
+TARGET_RZA1H,true,bool,defined(TARGET_RZA1H),false
+TARGET_RZA1L,true,bool,defined(TARGET_RZA1L),false
 TA_NEGEDGE
 TA_POSEDGE
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_timer.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_timer.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_timer.c	(revision 429)
@@ -4,5 +4,5 @@
  *      Advanced Standard Profile Kernel
  * 
- *  Copyright (C) 2006-2017 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2006-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -100,37 +100,4 @@
 
 /*
- *  高分解能タイマへの割込みタイミングの設定
- */
-void
-target_hrt_set_event(HRTCNT hrtcnt)
-{
-	uint32_t	cnt = hrtcnt * 33 + hrtcnt / 3 + 1;
-	uint32_t	current;
-
-	/*
-	 *  現在のカウント値を読み，hrtcnt後に割込みが発生するように設定する．
-	 */
-	current = sil_rew_mem(OSTM_CNT(OSTM0_BASE));
-	sil_wrw_mem(OSTM_CMP(OSTM0_BASE), current + cnt);
-
-	/*
-	 *  上で現在のカウント値を読んで以降に，cnt以上カウントアップしてい
-	 *  た場合には，割込みを発生させる．
-	 */
-	if (sil_rew_mem(OSTM_CNT(OSTM0_BASE)) - current >= cnt) {
-		raise_int(INTNO_OSTM0);
-	}
-}
-
-/*
- *  高分解能タイマ割込みの要求
- */
-void
-target_hrt_raise_event(void)
-{
-	raise_int(INTNO_OSTM0);
-}
-
-/*
  *  タイマ割込みハンドラ
  */
@@ -143,4 +110,5 @@
 	signal_time();
 }
+
 /*
  *  オーバランタイマドライバ
@@ -183,50 +151,4 @@
 
 /*
- *  オーバランタイマの停止
- */
-PRCTIM
-target_ovrtimer_stop(void)
-{
-	uint32_t	cnt;
-
-	/*
-	 *  OSタイマを停止する．
-	 */
-	sil_wrb_mem(OSTM_TT(OSTM1_BASE), OSTM_TT_STOP);
-
-	if (probe_int(INTNO_OSTM1)) {
-		/*
-		 *  割込み要求が発生している場合
-		 */
-		clear_int(INTNO_OSTM1);
-		return(0U);
-	}
-	else {
-		cnt = sil_rew_mem(OSTM_CNT(OSTM1_BASE));
-		return((PRCTIM)((cnt + 34) / 5 * 3 / 20));
-	}
-}
-
-/*
- *  オーバランタイマの現在値の読出し
- */
-PRCTIM
-target_ovrtimer_get_current(void)
-{
-	uint32_t	cnt;
-
-	if (probe_int(INTNO_OSTM1)) {
-		/*
-		 *  割込み要求が発生している場合
-		 */
-		return(0U);
-	}
-	else {
-		cnt = sil_rew_mem(OSTM_CNT(OSTM1_BASE));
-		return((PRCTIM)((cnt + 34) / 5 * 3 / 20));
-	}
-}
-
-/*
  *  オーバランタイマ割込みハンドラ
  *
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_timer.cfg
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_timer.cfg	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_timer.cfg	(revision 429)
@@ -1,4 +1,4 @@
 /*
- *		タイマドライバのコンフィギュレーションファイル
+ *		タイマドライバのコンフィギュレーションファイル（RZ/A1 OSタイマ用）
  *
  *  $Id$
@@ -10,4 +10,5 @@
 ATT_INI({ TA_NULL, 0, _kernel_target_hrt_initialize });
 ATT_TER({ TA_NULL, 0, _kernel_target_hrt_terminate });
+
 CFG_INT(INTNO_TIMER, { TA_ENAINT|INTATR_TIMER, INTPRI_TIMER });
 DEF_INH(INHNO_TIMER, { TA_NULL, _kernel_target_hrt_handler });
@@ -17,7 +18,10 @@
  */
 #ifdef TOPPERS_SUPPORT_OVRHDR
+
 ATT_INI({ TA_NULL, 0, _kernel_target_ovrtimer_initialize });
 ATT_TER({ TA_NULL, 0, _kernel_target_ovrtimer_terminate });
+
 CFG_INT(INTNO_OVRTIMER, { TA_ENAINT|INTATR_OVRTIMER, INTPRI_OVRTIMER });
 DEF_INH(INHNO_OVRTIMER, { TA_NULL, _kernel_target_ovrtimer_handler });
+
 #endif /* TOPPERS_SUPPORT_OVRHDR */
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_timer.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_timer.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_timer.h	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2005-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -51,4 +51,5 @@
 #define TOPPERS_CHIP_TIMER_H
 
+#include "kernel/kernel_impl.h"
 #include <sil.h>
 #include "rza1.h"
@@ -140,10 +141,33 @@
  *  生させるように設定する．
  */
-extern void target_hrt_set_event(HRTCNT hrtcnt);
+Inline void
+target_hrt_set_event(HRTCNT hrtcnt)
+{
+	uint32_t	cnt = hrtcnt * 33 + hrtcnt / 3 + 1;
+	uint32_t	current;
+
+	/*
+	 *  現在のカウント値を読み，hrtcnt後に割込みが発生するように設定する．
+	 */
+	current = sil_rew_mem(OSTM_CNT(OSTM0_BASE));
+	sil_wrw_mem(OSTM_CMP(OSTM0_BASE), current + cnt);
+
+	/*
+	 *  上で現在のカウント値を読んで以降に，cnt以上カウントアップしてい
+	 *  た場合には，割込みを発生させる．
+	 */
+	if (sil_rew_mem(OSTM_CNT(OSTM0_BASE)) - current >= cnt) {
+		raise_int(INTNO_OSTM0);
+	}
+}
 
 /*
  *  高分解能タイマ割込みの要求
  */
-extern  void target_hrt_raise_event(void);
+Inline void
+target_hrt_raise_event(void)
+{
+	raise_int(INTNO_OSTM0);
+}
 
 /*
@@ -184,10 +208,46 @@
  *  オーバランタイマの停止
  */
-extern PRCTIM target_ovrtimer_stop(void);
+Inline PRCTIM
+target_ovrtimer_stop(void)
+{
+	uint32_t	cnt;
+
+	/*
+	 *  OSタイマを停止する．
+	 */
+	sil_wrb_mem(OSTM_TT(OSTM1_BASE), OSTM_TT_STOP);
+
+	if (probe_int(INTNO_OSTM1)) {
+		/*
+		 *  割込み要求が発生している場合
+		 */
+		clear_int(INTNO_OSTM1);
+		return(0U);
+	}
+	else {
+		cnt = sil_rew_mem(OSTM_CNT(OSTM1_BASE));
+		return((PRCTIM)((cnt + 34) / 5 * 3 / 20));
+	}
+}
 
 /*
  *  オーバランタイマの現在値の読出し
  */
-extern PRCTIM target_ovrtimer_get_current(void);
+Inline PRCTIM
+target_ovrtimer_get_current(void)
+{
+	uint32_t	cnt;
+
+	if (probe_int(INTNO_OSTM1)) {
+		/*
+		 *  割込み要求が発生している場合
+		 */
+		return(0U);
+	}
+	else {
+		cnt = sil_rew_mem(OSTM_CNT(OSTM1_BASE));
+		return((PRCTIM)((cnt + 34) / 5 * 3 / 20));
+	}
+}
 
 /*
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_unrename.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_unrename.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/chip_unrename.h	(revision 429)
@@ -16,11 +16,7 @@
 #undef target_hrt_initialize
 #undef target_hrt_terminate
-#undef target_hrt_set_event
-#undef target_hrt_raise_event
 #undef target_hrt_handler
 #undef target_ovrtimer_initialize
 #undef target_ovrtimer_terminate
-#undef target_ovrtimer_stop
-#undef target_ovrtimer_get_current
 #undef target_ovrtimer_handler
 
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/rza1.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/rza1.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/rza1.h	(revision 429)
@@ -2,8 +2,8 @@
  *  TOPPERS Software
  *      Toyohashi Open Platform for Embedded Real-Time Systems
- *
- *  Copyright (C) 2006-2016 by Embedded and Real-Time Systems Laboratory
+ * 
+ *  Copyright (C) 2006-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
- *
+ * 
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
  *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
@@ -28,5 +28,5 @@
  *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
  *      免責すること．
- *
+ * 
  *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
  *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
@@ -34,5 +34,5 @@
  *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
  *  の責任を負わない．
- *
+ * 
  *  $Id$
  */
@@ -45,5 +45,7 @@
 #define TOPPERS_RZA1_H
 
+#include <kernel.h>
 #include <sil.h>
+#include "arm.h"
 
 /*
@@ -84,4 +86,9 @@
 
 /*
+ *  CP15の補助制御レジスタ（ACTLR）の設定値
+ */
+#define CP15_ACTLR_SMP		UINT_C(0x00000040)
+
+/*
  *  GIC依存部を使用するための定義
  */
@@ -92,5 +99,5 @@
 #define GIC_TNUM_INTNO		UINT_C(538)
 #endif /* TOPPERS_RZA1H */
-#endif /* GIC_TNUM_INT */
+#endif /* GIC_TNUM_INTNO */
 
 /*
@@ -256,5 +263,5 @@
 	reg = sil_reh_mem(RZA1_IRQRR);
 	reg &= ~(0x01U << (intno - INTNO_IRQ0));
-	sil_wrh_mem(RZA1_IRQRR, reg);
+	sil_swrh_mem(RZA1_IRQRR, reg);
 }
 
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/scif.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/scif.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/scif.h	(revision 429)
@@ -1,12 +1,11 @@
 /*
- *  TOPPERS/ASP Kernel
- *      Toyohashi Open Platform for Embedded Real-Time Systems/
- *      Advanced Standard Profile Kernel
- *
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
+ * 
  *  Copyright (C) 2001-2011 by Industrial Technology Institute,
  *                              Miyagi Prefectural Government, JAPAN
  *  Copyright (C) 2007-2016 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
- *
+ * 
  *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
  *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
@@ -31,5 +30,5 @@
  *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
  *      免責すること．
- *
+ * 
  *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
  *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
@@ -37,5 +36,5 @@
  *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
  *  の責任を負わない．
- *
+ * 
  *  $Id$
  */
@@ -66,8 +65,13 @@
  *  シリアルモードレジスタ（SCIF_SCSMR）の設定値
  */
+#define SCIF_SCSMR_ASYNC	0x0000U		/* 調歩同期式モード */
 #define SCIF_SCSMR_SYNC		0x0080U		/* クロック同期式モード */
+#define SCIF_SCSMR_8BIT		0x0000U		/* 8ビットデータ */
 #define SCIF_SCSMR_7BIT		0x0040U		/* 7ビットデータ */
-#define SCIF_SCSMR_PARITY	0x0020U		/* パリティビットの付加 */
+#define SCIF_SCSMR_NOPARITY	0x0000U		/* パリティビットなし */
+#define SCIF_SCSMR_PARITY	0x0020U		/* パリティビット付加 */
+#define SCIF_SCSMR_EVEN		0x0000U		/* 偶数パリティ */
 #define SCIF_SCSMR_ODD		0x0010U		/* 奇数パリティ */
+#define SCIF_SCSMR_1STOP	0x0000U		/* 1ストッピビット */
 #define SCIF_SCSMR_2STOP	0x0008U		/* 2ストッピビット */
 #define SCIF_SCSMR_CKS1		0x0000U		/* P1φクロック1 */
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/tSCIF.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/tSCIF.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/tSCIF.c	(revision 429)
@@ -1,8 +1,7 @@
 /*
- *  TOPPERS/ASP Kernel
- *      Toyohashi Open Platform for Embedded Real-Time Systems/
- *      Advanced Standard Profile Kernel
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
- *  Copyright (C) 2006-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2006-2019 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -133,37 +132,38 @@
 	uint_t	brr;
 
-	if (VAR_initialized) {
-		/*
-		 *  既に初期化している場合は、二重に初期化しない．
-		 */
-		return;
-	}
-
-	brr = SCIF_CLK / (32 * ATTR_baudRate) - 1;
-	assert(brr <= 255);
-
-	sil_wrh_mem(SCIF_SCSCR(ATTR_baseAddress), 0U);
-	sil_wrh_mem(SCIF_SCFCR(ATTR_baseAddress),
+	if (!VAR_opened) {
+		/*
+		 *  既にオープンしている場合は、二重にオープンしない．
+		 */
+		brr = SCIF_CLK / (32 * ATTR_baudRate) - 1;
+		assert(brr <= 255);
+
+		sil_wrh_mem(SCIF_SCSCR(ATTR_baseAddress), 0U);
+		sil_wrh_mem(SCIF_SCFCR(ATTR_baseAddress),
 							SCIF_SCFCR_TFRST|SCIF_SCFCR_RFRST);
-	(void) sil_reh_mem(SCIF_SCFSR(ATTR_baseAddress));
-	(void) sil_reh_mem(SCIF_SCLSR(ATTR_baseAddress));
-	sil_wrh_mem(SCIF_SCFSR(ATTR_baseAddress), 0U);
-	sil_wrh_mem(SCIF_SCLSR(ATTR_baseAddress), 0U);
-	sil_wrh_mem(SCIF_SCSCR(ATTR_baseAddress), SCIF_SCSCR_INTCLK);
-	sil_wrh_mem(SCIF_SCSMR(ATTR_baseAddress), SCIF_SCSMR_CKS1);
-	sil_wrh_mem(SCIF_SCEMR(ATTR_baseAddress), 0U);
-	sil_wrb_mem(SCIF_SCBRR(ATTR_baseAddress), (uint8_t) brr);
-	sil_wrh_mem(SCIF_SCFCR(ATTR_baseAddress),
+		(void) sil_reh_mem(SCIF_SCFSR(ATTR_baseAddress));
+		(void) sil_reh_mem(SCIF_SCLSR(ATTR_baseAddress));
+		sil_wrh_mem(SCIF_SCFSR(ATTR_baseAddress), 0U);
+		sil_wrh_mem(SCIF_SCLSR(ATTR_baseAddress), 0U);
+		sil_wrh_mem(SCIF_SCSCR(ATTR_baseAddress), SCIF_SCSCR_INTCLK);
+		sil_wrh_mem(SCIF_SCSMR(ATTR_baseAddress),
+							SCIF_SCSMR_ASYNC|ATTR_mode|SCIF_SCSMR_CKS1);
+		sil_wrh_mem(SCIF_SCEMR(ATTR_baseAddress), 0U);
+		sil_wrb_mem(SCIF_SCBRR(ATTR_baseAddress), (uint8_t) brr);
+		sil_wrh_mem(SCIF_SCFCR(ATTR_baseAddress),
 					SCIF_SCFCR_RSTRG_15|SCIF_SCFCR_RTRG_1|SCIF_SCFCR_TTRG_8);
-	sil_wrh_mem(SCIF_SCSCR(ATTR_baseAddress),
+		sil_wrh_mem(SCIF_SCSCR(ATTR_baseAddress),
 					SCIF_SCSCR_TE|SCIF_SCSCR_RE|SCIF_SCSCR_INTCLK);
 
-	while ((sil_reh_mem(SCIF_SCFSR(ATTR_baseAddress)) & SCIF_SCFSR_RDF) != 0U) {
-		(void) sil_reb_mem(SCIF_SCFRDR(ATTR_baseAddress));
-		sil_wrh_mem(SCIF_SCFSR(ATTR_baseAddress), (uint16_t) ~(SCIF_SCFSR_RDF));
-	}
-	sil_wrh_mem(SCIF_SCFSR(ATTR_baseAddress), 0U);
-
-	VAR_initialized = true;
+		while ((sil_reh_mem(SCIF_SCFSR(ATTR_baseAddress)) & SCIF_SCFSR_RDF)
+																	!= 0U) {
+			(void) sil_reb_mem(SCIF_SCFRDR(ATTR_baseAddress));
+			sil_wrh_mem(SCIF_SCFSR(ATTR_baseAddress),
+							(uint16_t) ~(SCIF_SCFSR_RDF));
+		}
+		sil_wrh_mem(SCIF_SCFSR(ATTR_baseAddress), 0U);
+
+		VAR_opened = true;
+	}
 }
 
@@ -176,5 +176,9 @@
 	CELLCB	*p_cellcb = GET_CELLCB(idx);
 
-	sil_wrh_mem(SCIF_SCSCR(ATTR_baseAddress), 0U);
+	if (VAR_opened) {
+		sil_wrh_mem(SCIF_SCSCR(ATTR_baseAddress), 0U);
+
+		VAR_opened = false;
+	}
 }
 
@@ -284,2 +288,23 @@
 	}
 }
+
+/*
+ *  SIOドライバの終了処理
+ */
+void
+eTerminate_main(CELLIDX idx)
+{
+	CELLCB	*p_cellcb = GET_CELLCB(idx);
+
+	if (VAR_opened) {
+		/*
+		 *  送信FIFOが空になるまで待つ
+		 */
+		while ((sil_reh_mem(SCIF_SCFSR(ATTR_baseAddress))
+											& SCIF_SCFSR_TEND) == 0U) ;
+		/*
+		 *  ポートのクローズ
+		 */
+		eSIOPort_close(idx);
+	}
+}
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/tSCIF.cdl
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/tSCIF.cdl	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/rza1/tSCIF.cdl	(revision 429)
@@ -5,5 +5,5 @@
  *  Copyright (C) 2015 by Ushio Laboratory
  *              Graduate School of Engineering Science, Osaka Univ., JAPAN
- *  Copyright (C) 2015,2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2015-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -61,11 +61,13 @@
 	entry	siHandlerBody	eiRxISR;
 	entry	siHandlerBody	eiTxISR;
+	entry	sRoutineBody	eTerminate;
 
 	attr {
 		uintptr_t	baseAddress;	/* SCIFレジスタのベースアドレス */
-		uint32_t	baudRate;		/* ボーレートの設定値 */
+		uint16_t	mode;			/* モードレジスタの設定値 */
+		uint32_t	baudRate;		/* ボーレート */
 	};
 	var {
-		bool_t		initialized = false;	/* 初期化済み */
+		bool_t		opened = false;	/* オープン済み */
 	};
 };
Index: EcnlProtoTool/trunk/asp3_dcre/arch/gcc/tool_stddef.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/gcc/tool_stddef.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/gcc/tool_stddef.h	(revision 429)
@@ -5,5 +5,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2004-2011 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2004-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -90,6 +90,6 @@
  *
  *  TOPPERS_STDINT_TYPE1: char/short/int/long longのビット長がそれぞれ
- *                        8/16/32/64ビットで，ポインタのビット長がlong
- *                        のビット長と一致する場合
+ *                        8/16/32/64ビットで，size_tとポインタのビット
+ *                        長がlongのビット長と一致する場合
  */
 #ifdef TOPPERS_STDINT_TYPE1
@@ -177,4 +177,6 @@
 #define INT_LEAST8_MIN		INT8_MIN
 #define UINT_LEAST8_MAX		INT8_MAX
+
+#define SIZE_MAX			ULONG_MAX
 
 #endif /* TOPPERS_STDINT_TYPE1 */
Index: EcnlProtoTool/trunk/asp3_dcre/arch/tracelog/tTraceLog.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/tracelog/tTraceLog.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/tracelog/tTraceLog.c	(revision 429)
@@ -5,5 +5,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2005-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2019 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -48,4 +48,7 @@
 #include "kernel/task.h"
 #include "kernel/time_event.h"
+#ifdef TOPPERS_SUPPORT_PROTECT
+#include "kernel/domain.h"
+#endif /* TOPPERS_SUPPORT_PROTECT */
 #include <sil.h>
 #include <log_output.h>
@@ -56,14 +59,14 @@
  *
  *  デフォルトでは，ログ時刻として，高分解能タイマのカウント値を用いて
- *  いる．ターゲット依存で変更する場合には，SYSLOG_GET_LOGTIMに，ログ時
+ *  いる．ターゲット依存で変更する場合には，TRACE_GET_LOGTIMに，ログ時
  *  刻を取り出すマクロを定義する．
  */
-#ifndef SYSLOG_GET_LOGTIM
-#define SYSLOG_GET_LOGTIM(p_logtim) \
+#ifndef TRACE_GET_LOGTIM
+#define TRACE_GET_LOGTIM(p_logtim) \
 				(*(p_logtim) = target_hrt_get_current())
-#endif /* SYSLOG_GET_TIM */
-
-/*
- *  トレースログの開始
+#endif /* TRACE_GET_TIM */
+
+/*
+ *  トレースログの開始（受け口関数）
  */
 ER
@@ -81,5 +84,5 @@
 
 /* 
- *  トレースログの書込み
+ *  トレースログの書込み（受け口関数）
  */
 ER
@@ -94,5 +97,5 @@
 		 *  トレース時刻の設定
 		 */
-		SYSLOG_GET_LOGTIM(&(((SYSLOG *) p_trace)->logtim));
+		TRACE_GET_LOGTIM(&(((SYSLOG *) p_trace)->logtim));
 
 		/*
@@ -121,5 +124,5 @@
 
 /*
- *  トレースログの読出し
+ *  トレースログの読出し（受け口関数）
  */
 ER
@@ -203,5 +206,5 @@
 	p_tcb = (TCB *) info;
 	if (p_tcb == NULL) {
-		tskid = 0;
+		tskid = TSK_NONE;
 	}
 	else {
@@ -240,4 +243,35 @@
 }
 
+#ifdef TOPPERS_SUPPORT_PROTECT
+
+static intptr_t
+get_somid(intptr_t info)
+{
+	SOMINIB	*p_sominib;
+	ID		somid;
+
+	p_sominib = (SOMINIB *) info;
+	if (p_sominib == NULL) {
+		somid = TSOM_STP;
+	}
+	else {
+		somid = SOMID(p_sominib);
+	}
+	return((intptr_t) somid);
+}
+
+static intptr_t
+get_twd_domid(intptr_t info)
+{
+	TWDINIB	*p_twdinib;
+	ID		domid;
+
+	p_twdinib = (TWDINIB *) info;
+	domid = (ID)(p_twdinib->p_dominib - dominib_table) + TMIN_DOMID;
+	return((intptr_t) domid);
+}
+
+#endif /* TOPPERS_SUPPORT_PROTECT */
+
 /* 
  *  トレースログの表示
@@ -267,4 +301,21 @@
 		tracemsg = "dispatch to task %d.";
 		break;
+
+#ifdef TOPPERS_SUPPORT_PROTECT
+	case LOG_TYPE_SCYC|LOG_START:
+		traceinfo[0] = get_somid(p_trace->logpar[0]);
+		tracemsg = "system cycle starts with system operating mode %d.";
+		break;
+	case LOG_TYPE_TWD|LOG_START:
+		if (p_trace->logpar[0] == 0) {
+			tracemsg = "idle window starts.";
+		}
+		else {
+			traceinfo[0] = get_twd_domid(p_trace->logpar[0]);
+			tracemsg = "time window for domain %d starts.";
+		}
+		break;
+#endif /* TOPPERS_SUPPORT_PROTECT */
+
 	case LOG_TYPE_COMMENT:
 		for (i = 1; i < TNUM_LOGPAR; i++) {
@@ -313,9 +364,9 @@
 }
 
-/* 
- *  トレースログのダンプ
- */
-void
-eTraceLog_dump(void)
+/*
+ *  トレースログのダンプ（受け口関数）
+ */
+void
+eDump_main(uintptr_t exinf)
 {
 	TRACE	trace;
@@ -325,11 +376,2 @@
 	}
 }
-
-/*
- *  トレースログのダンプ（受け口関数）
- */
-void
-tTraceLog_eDump_main(uintptr_t exinf)
-{
-	eTraceLog_dump();
-}
Index: EcnlProtoTool/trunk/asp3_dcre/arch/tracelog/tTraceLog.cdl
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/tracelog/tTraceLog.cdl	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/tracelog/tTraceLog.cdl	(revision 429)
@@ -1,10 +1,9 @@
 /*
- *  TOPPERS/ASP Kernel
- *      Toyohashi Open Platform for Embedded Real-Time Systems/
- *      Advanced Standard Profile Kernel
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
  *  Copyright (C) 2015 by Ushio Laboratory
  *              Graduate School of Engineering Science, Osaka Univ., JAPAN
- *  Copyright (C) 2015,2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2015-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -68,9 +67,4 @@
 	 */
 	ER		read([out] TRACE *p_trace);
-
-	/*
-	 *  トレースログのダンプ
-	 */
-	void	dump(void);
 };
 
@@ -81,6 +75,6 @@
 celltype tTraceLog {
 	entry	sTraceLog		eTraceLog;
-	entry	sRoutineBody	eDump;		/* 終了処理ルーチンとの接続 */
-	call	sPutLog			cPutLog;	/* 低レベル出力との接続 */
+	entry	sRoutineBody	eDump;		/* トレースログのダンプ */
+	call	sPutLog			cPutLog;	/* ダンプ先との接続 */
 
 	attr {
Index: EcnlProtoTool/trunk/asp3_dcre/arch/tracelog/trace_log.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/tracelog/trace_log.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/tracelog/trace_log.h	(revision 429)
@@ -5,5 +5,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2004-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2004-2019 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -41,14 +41,14 @@
 
 /*
- *		トレースログに関する設定
+ *		トレースログ機能のヘッダファイル
  *
  *  このインクルードファイルは，target_kernel_impl.hおよび
- *  target_syssvc.hのみからインクルードされる．また，トレースログ機能の
- *  初期化や記録の開始／停止，トレースログのダンプを行うプログラムから
- *  インクルードすることを想定している．
- */
-
-#ifndef TOPPERS_TRACE_CONFIG_H
-#define TOPPERS_TRACE_CONFIG_H
+ *  target_syssvc.hからインクルードされる．また，トレースログ機能の初
+ *  期化や記録の開始／停止，トレースログのダンプを行うプログラムからイ
+ *  ンクルードすることを想定している．
+ */
+
+#ifndef TOPPERS_TRACE_LOG_H
+#define TOPPERS_TRACE_LOG_H
 
 /*
@@ -75,5 +75,5 @@
 
 /*
- *  TECSで記述されたテストプログラム用のサービスを直接呼び出すための定義
+ *  TECSで記述されたトレースログ機能を直接呼び出すための定義
  *
  *  C言語で記述されたアプリケーションから，TECSで記述されたトレースログ
@@ -134,5 +134,5 @@
 
 Inline void
-trace_write_1(uint_t type, intptr_t arg1)
+trace_write_1(uint_t type, LOGPAR arg1)
 {
 	TRACE	trace;
@@ -144,5 +144,5 @@
 
 Inline void
-trace_write_2(uint_t type, intptr_t arg1, intptr_t arg2)
+trace_write_2(uint_t type, LOGPAR arg1, LOGPAR arg2)
 {
 	TRACE	trace;
@@ -155,5 +155,5 @@
 
 Inline void
-trace_write_3(uint_t type, intptr_t arg1, intptr_t arg2, intptr_t arg3)
+trace_write_3(uint_t type, LOGPAR arg1, LOGPAR arg2, LOGPAR arg3)
 {
 	TRACE	trace;
@@ -174,20 +174,15 @@
 
 #define trace_1(type, arg1) \
-				trace_write_1(type, (intptr_t)(arg1))
+				trace_write_1(type, (LOGPAR)(arg1))
 
 #define trace_2(type, arg1, arg2) \
-				trace_write_2(type, (intptr_t)(arg1), (intptr_t)(arg2))
+				trace_write_2(type, (LOGPAR)(arg1), (LOGPAR)(arg2))
 
 #define trace_3(type, arg1, arg2, arg3) \
-				trace_write_3(type, (intptr_t)(arg1), (intptr_t)(arg2), \
-														(intptr_t)(arg3))
+				trace_write_3(type, (LOGPAR)(arg1), (LOGPAR)(arg2), \
+														(LOGPAR)(arg3))
 
 /* 
  *  トレースログのダンプ
- *
- *  トレースログをダンプする．終了処理ルーチンとして登録することも想定
- *  している．引数として，ダンプ先となる文字出力関数へのポインタを渡す．
- *  ターゲット依存の低レベル文字出力を利用する場合には，target_putcを渡
- *  す．
  */
 Inline void
@@ -203,7 +198,14 @@
  */
 #define LOG_TSKSTAT(p_tcb)		trace_2(LOG_TYPE_TSKSTAT, p_tcb, p_tcb->tstat)
+
+#define LOG_DSP_LEAVE(p_tcb)	trace_1(LOG_TYPE_DSP|LOG_LEAVE, p_tcb)
+
+#ifdef TOPPERS_SUPPORT_PROTECT
+#define LOG_SCYC_START(p_sominib)	trace_1(LOG_TYPE_SCYC|LOG_START, p_sominib)
+#define LOG_TWD_START(p_twdinib)	trace_1(LOG_TYPE_TWD|LOG_START, p_twdinib)
+#endif /* TOPPERS_SUPPORT_PROTECT */
 
 #define LOG_TSYSLOG_ESYSLOG_WRITE_ENTER(priority, p_syslog) \
 								trace_wri_log((TRACE *) p_syslog)
 
-#endif /* TOPPERS_TRACE_CONFIG_H */
+#endif /* TOPPERS_TRACE_LOG_H */
Index: EcnlProtoTool/trunk/asp3_dcre/cfg/GenFile.rb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/cfg/GenFile.rb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/cfg/GenFile.rb	(revision 429)
@@ -37,5 +37,5 @@
 #  の責任を負わない．
 #
-#  $Id$
+#  $Id: GenFile.rb 111 2016-03-16 23:50:27Z ertl-hiro $
 #
 
Index: EcnlProtoTool/trunk/asp3_dcre/cfg/MANIFEST
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/cfg/MANIFEST	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/cfg/MANIFEST	(revision 429)
@@ -1,2 +1,5 @@
+PACKAGE cfg
+VERSION 1.5.0
+
 MANIFEST
 cfg.rb
Index: EcnlProtoTool/trunk/asp3_dcre/cfg/SRecord.rb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/cfg/SRecord.rb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/cfg/SRecord.rb	(revision 429)
@@ -36,5 +36,5 @@
 #  の責任を負わない．
 #
-#  $Id$
+#  $Id: SRecord.rb 161 2018-12-12 00:45:04Z ertl-hiro $
 #
 
@@ -170,3 +170,15 @@
     end
   end
+
+  # 文字列としてのデータ取得
+  def get_string(address)
+    str = ""
+    targetChar = get_data(address, 1).hex
+    while (!targetChar.nil? && targetChar != 0)
+      str += targetChar.chr
+      address += 1
+      targetChar = get_data(address, 1).hex
+    end
+    return(str)
+  end
 end
